/**************************************************************************
 *
 *	project				 : VisiScript
 *
 *	copyright            : (C) 2002 by Michael Neuroth
 *
 * ------------------------------------------------------------------------
 *
 *  $Source$
 *
 *  $Revision$
 *
 *	$Log$
 *
 ***************************************************************************/
/*********************************************************************************
 *																				 *
 * This file is part of the VisiScript package (a frontend for script languages) *
 *																				 *
 * Copyright (C) 2002 by Michael Neuroth.										 *
 *                                                                               *
 * This program is free software; you can redistribute it and/or modify			 *
 * it under the terms of the GNU General Public License as published by    		 *
 * the Free Software Foundation; either version 2 of the License, or             *
 * (at your option) any later version.                                           *
 *                                                                               *
 ********************************************************************************/

#ifndef _CODEEDIT_H
#define _CODEEDIT_H

#include <qstring.h>
#include <qfont.h>
#include "qextscintilla.h"

class QextScintillaLexer;
class QDropEvent;
class QTabWidget;
class QWidget;

class MyQCodeEdit : public QextScintilla
{
	Q_OBJECT

public:
	MyQCodeEdit( QWidget * parent=0, const char * name=0, QTabWidget * pTabWidget = 0, QWidget * pTab = 0, QWidget * pMainWin = 0 );
	~MyQCodeEdit();

	bool hasMarkedTxt();
	QString markedTxt();

	void setLexer( QextScintillaLexer * pLexer );
	void updateFontForLexer( const QFont & aFont );

	void setWordWrap( bool bValue );
	void setOverwriteMode( bool bValue );
	bool overwriteMode();
	void setEdited( bool bValue );
	bool edited();
//	void setFont( const QFont & f );
//	void setHorizScrollbar( bool bVisible );
//	void setMaxWidth( int iCount );

	void setFileName( const QString & sFileName );
	QString fileName() const;

public slots:
	void sltChanged();
	void sltNotChanged();

	virtual void show();

signals:
	void isShowing();

private:
	void UpdateTabName();

	QextScintillaLexer *	m_pLexer;
	QString					m_sFileName;
	QTabWidget *			m_pTabWidget;	// not an owner !
	QWidget *				m_pTab;			// not an owner !
	bool					m_bChanged;
};

#endif
